config/routes.rb
Rails.application.routes.draw do


  get 'logout' => 'sessions#logout'
  get 'login' => 'sessions#login'
  post 'login_process' => 'sessions#login_process'
  get 'welcome_user' => 'sessions#welcome_user'
  get 'student_rank' => 'students#student_rank'

  
  resources :student_marks
  resources :subjects
  resources :students
  resources :users
  resources :roles

  root 'sessions#login'

  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/user.rb
class User < ApplicationRecord
  belongs_to :role
  
  require 'bcrypt'

  has_secure_password

    
  validates_uniqueness_of :user_name, presence: true, :message => "Already Exists"
  validates_uniqueness_of :email_id, :message => "Already Exists"

end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :set_user, only: [:show, :edit, :update, :destroy]

  # GET /users
  # GET /users.json
  def index
    # @users = User.all
    @users = User.where.not(role_id: 1)
  end

  # GET /users/1
  # GET /users/1.json
  def show
  end

  # GET /users/new
  def new
    @user = User.new
  end

  # GET /users/1/edit
  def edit
  end

  # POST /users
  # POST /users.json
  def create
    @user = User.new(user_params)

    respond_to do |format|
      if @user.save
        format.html { redirect_to users_url, notice: 'User was successfully created.' }
        format.json { render :show, status: :created, location: @user }
      else
        format.html { render :new }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /users/1
  # PATCH/PUT /users/1.json
  def update
    respond_to do |format|
      if @user.update(user_params)
        format.html { redirect_to users_url, notice: 'User was successfully updated.' }
        format.json { render :show, status: :ok, location: @user }
      else
        format.html { render :edit }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /users/1
  # DELETE /users/1.json
  def destroy
    @user.destroy
    respond_to do |format|
      format.html { redirect_to users_url, notice: 'User was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_user
      @user = User.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def user_params
      params.require(:user).permit(:user_name, :email_id, :password, :education_qualification, :role_id)
    end
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/users/_form.html.erb
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">

<%= form_with(model: user, local: true) do |form| %>
  <% if user.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(user.errors.count, "error") %> prohibited this user from being saved:</h2>

      <ul>
      <% user.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>
  <div class="container">
    <div class="form-group row">
      <div class="col-md-5">
        <%= form.label :user_name, class: "col-form-label" %>
        <%= form.text_field :user_name, id: :user_user_name, class: "form-control", required: true %>
      </div>

      <div class="col-md-5">
        <%= form.label :email_id, class: "col-form-label" %>
        <%= form.text_field :email_id, id: :user_email_id, class: "form-control", required: true %>
      </div>
      
      <div class="col-md-5">
        <%= form.label :password, class: "col-form-label" %>
        <%= form.password_field :password, id: "password-field", class: "form-control", required: true %>
      </div> 

      <div class="col-md-5">
        <%= form.label :education_qualification, class: "col-form-label" %>
        <%= form.text_field :education_qualification, id: :education_qualification, class: "form-control", required: true %>
      </div>
    </div>
      <%= form.hidden_field :role_id, value: 2  %>
    <div class="actions col-md-12 mt-4">
      <%= form.submit "Submit", class:"btn btn-primary float-right" %>
      <%= link_to "Cancel", users_path, class: "btn btn-warning float-right mr-3" %>
    </div>
  </div>
<% end %>

app/views/users/edit.html.erb
<h1>Editing User</h1>

<%= render 'form', user: @user %>

<%#= link_to 'Show', @user, class: "btn btn-info float-right mr-3" %> 

app/views/users/index.html.erb
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
<script src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"> </script>

<br>
<div style="margin-top: 50px" class="row page-titles">
  <div class="col-md-5 align-self-center">
    <h3 class="text-primary">Teachers</h3>
  </div>
</div>

<div class="container">
  <div class="card top">
    <div class="row">
      <div class="col-md-1 pull-right">
        <%= link_to 'New', new_user_path , class: "btn btn-info float-right mr-3" %> 
      </div>
      <div class="col-md-1 pull-right">
        <%= link_to 'Back', welcome_user_path , class: "btn btn-warning float-right mr-3" %>
      </div>
    </div>
  </div>
</div>
<br>

<table id="teacher_list">
  <thead>
    <tr>
      <th>User name</th>
      <th>Email</th>
      <!-- <th>Password</th> -->
      <th>Education qualification</th>
      <!-- <th>Role</th> -->
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @users.each do |user| %>
      <tr>
        <td><%= user.user_name %></td>
        <td><%= user.email_id %></td>
        <!-- <td><%#= user.password %></td> -->
        <td><%= user.education_qualification %></td>
        <!-- <td><%#= user.role_id %></td> -->
        <td><%= link_to "<i class='fa fa-eye' title='Teacher'></i>".html_safe, user %></td>
        <td><%= link_to "<i class='fa fa-pencil' title='Edit Teacher'></i>".html_safe, edit_user_path(user) %></td>
        <td><%= link_to "<i class='fa fa-trash' title='Delete Teacher'></i>".html_safe, user, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<script type="text/javascript">
  $(document).ready(function(){
    $('#teacher_list').dataTable();
  });
</script>

app/views/users/new.html.erb
<h1>New User</h1>

<%= render 'form', user: @user %>

app/views/users/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>User name:</strong>
  <%= @user.user_name %>
</p>

<p>
  <strong>Email:</strong>
  <%= @user.email_id %>
</p>

<p>
  <strong>Education qualification:</strong>
  <%= @user.education_qualification %>
</p>


<%= link_to 'Edit', edit_user_path(@user), class: "btn btn-danger float-right mr-3" %> 
<%= link_to "Back", users_path, class: "btn btn-warning float-right mr-3" %>